%% prepare data
tstart =clock;

%% test noiseless ...
numnodes = 37;
snr = 20;   %signal-noise-ratio
numepochs = 1500;

z=zeros(41,41,41);
% z=peaks(100);
for i = 1:41
    x = i/10 - 2.1;
    for j = 1:41
        y = j/10 - 2.1;
        for k = 1:41
            a = k/10 - 2.1;
%         z(i,j) = log(y)*x+log(x)*y-2*x/y;
% z = x y^2 a^3 + x^2 y^3 a + x^3 y a^2 ;  %  x,y,z [(-2:.1:+2)]
            z(i,j,k) = (x*y*y*a*a*a+x*x*y*y*y*a+x*x*x*y*a*a) /64;
        end    
    end
end
% mesh(z);

% no noise
y = z;
a=zeros(2,68921);
b=zeros(1,68921);
for i = 1:41
    for j = 1:41
        for k = 1:41
        b(1,(k-1)*41*41+(j-1)*41+(i-1)+1) = y(k,j,i);
%         a(j*100+i,1) = j - 50;
%         a(j*100+i,2) = i - 50;
        a(1,(k-1)*41*41+(j-1)*41+(i-1)+1) = k-21;
        a(2,(k-1)*41*41+(j-1)*41+(i-1)+1) = j-21;
        a(3,(k-1)*41*41+(j-1)*41+(i-1)+1) = i-21;
        
        end
    end
end
% trainbr0

net = feedforwardnet(numnodes,'trainbr');
net.trainParam.epochs = numepochs;
% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 80/100;
net.divideParam.valRatio = 10/100;
net.divideParam.testRatio = 10/100;

net = train(net,a,b);
c = net(a);
% evaluate
% for i = 1:100
%     for j = 1:100
%         e(j,i) =  c(1,j*100+i);
e=zeros(41,41,41);
for i = 1:41
    for j = 1:41
        for k = 1:41
        e(k,j,i)=c(1,(k-1)*41*41+(j-1)*41+(i-1)+1);
        end
    end
end
d = z-e;
errn = sum(sum(sum(abs(d))));
fprintf("Numnodes: %d.  Network error= %f\n",numnodes,errn);
diffxy= max(b)-min(b);
fprintf("minvalue= %f , maxvalue= %f\n",min(b),max(b));
relerr= errn/diffxy;
fprintf("Relative error= %f , x-y difference %f\n",relerr,diffxy);

%% main cycle
d5 = (1:5);
n5 = (1:5);
for m = 1:5

% *noise*
y = awgn(z,snr);
% y = z;
d = z-y;
d5(m) = sum(sum(sum(abs(d))));
 fprintf("noise %d dB=>%f\n",snr,d5(m));
% y = awgn(z,20);
% d = z-y;
% d20 = sum(sum(abs(d)));
% fprintf("noise 20 dB=>%f\n",d20);
% y = awgn(z,30);
% d = z-y;
% d30 = sum(sum(abs(d)));
% fprintf("noise 30 dB=>%f\n",d30);
% y = awgn(z,40);
% d = z-y;
% d40 = sum(sum(abs(d)));
% fprintf("noise 40 dB=>%f\n",d40);

% a=zeros(2,10001);
% b=zeros(1,10001);
% for i = 1:100
%     for j = 1:100
%         b(1,j*100+i) = y(j,i);
% %         a(j*100+i,1) = j - 50;
% %         a(j*100+i,2) = i - 50;
%         a(1,j*100+i) = j;
%         a(2,j*100+i) = i;
%     end
% end
a=zeros(2,68921);
b=zeros(1,68921);
for i = 1:41
    for j = 1:41
        for k = 1:41
        b(1,(k-1)*41*41+(j-1)*41+(i-1)+1) = y(k,j,i);
%         a(j*100+i,1) = j - 50;
%         a(j*100+i,2) = i - 50;
        a(1,(k-1)*41*41+(j-1)*41+(i-1)+1) = k-21;
        a(2,(k-1)*41*41+(j-1)*41+(i-1)+1) = j-21;
        a(3,(k-1)*41*41+(j-1)*41+(i-1)+1) = i-21;
        
        end
    end
end

%% trainbr

net = feedforwardnet(numnodes,'trainbr');
net.trainParam.epochs = numepochs;
% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 80/100;
net.divideParam.valRatio = 10/100;
net.divideParam.testRatio = 10/100;

net = train(net,a,b);
c = net(a);

%% evaluate network

%c=L25e(a);
% e=zeros(100);
% for i = 1:100
%     for j = 1:100
%         e(j,i) =  c(1,j*100+i);
%     end
% end
e=zeros(41,41,41);
for i = 1:41
    for j = 1:41
        for k = 1:41
        e(k,j,i)=c(1,(k-1)*41*41+(j-1)*41+(i-1)+1);
        end;
    end
end
d = z-e;
n5(m) = sum(sum(sum(abs(d))));
fprintf("Network error= %f\n",n5(m));
% diffxy= max(b)-min(b);
% relerr= errn/diffxy;
% fprintf("Relative error=%f, x-y difference %f\n",relerr,diffxy);

% mesh(e);

%%
end;

fprintf("Average error in data = %f\n",mean(d5));
fprintf("Average error by net  = %f\n",mean(n5));
% etime(clock,tstart)
fprintf("Elapsed time  = %f\n",etime(clock,tstart));
