%% prepare data

%% test noiseless ...
numnodes = 25;
snr = 5;   %signal-noise-ratio

z=zeros(100);
for i = 1:100
    x = 1+i/50;
    for j = 1:100
        y = 1+j/50;
        z(i,j) = log(y)*x+log(x)*y-2*x/y;
    end
end
% mesh(z);

% no noise
y = z;
a=zeros(2,10001);
b=zeros(1,10001);
for i = 1:100
    for j = 1:100
        b(1,j*100+i) = y(j,i);
%         a(j*100+i,1) = j - 50;
%         a(j*100+i,2) = i - 50;
        a(1,j*100+i) = j;
        a(2,j*100+i) = i;
    end
end
% trainbr0

net = feedforwardnet(numnodes,'trainbr');
net.trainParam.epochs = 1000;
% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 80/100;
net.divideParam.valRatio = 10/100;
net.divideParam.testRatio = 10/100;

net = train(net,a,b);
c = net(a);
% evaluate
e=zeros(100);
for i = 1:100
    for j = 1:100
        e(j,i) =  c(1,j*100+i);
    end
end
d = z-e;
errn = sum(sum(abs(d)));
fprintf("Network error= %f\n",errn);
diffxy= max(b)-min(b);
fprintf("minvalue= %f , maxvalue= %f\n",min(b),max(b));
relerr= errn/diffxy;
fprintf("Relative error= %f , x-y difference %f\n",relerr,diffxy);

%% main cycle
d5 = (1:5);
n5 = (1:5);
for k = 1:5

% *noise*
y = awgn(z,snr);
% y = z;
d = z-y;
d5(k) = sum(sum(abs(d)));
 fprintf("noise %d dB=>%f\n",snr,d5(k));
% y = awgn(z,20);
% d = z-y;
% d20 = sum(sum(abs(d)));
% fprintf("noise 20 dB=>%f\n",d20);
% y = awgn(z,30);
% d = z-y;
% d30 = sum(sum(abs(d)));
% fprintf("noise 30 dB=>%f\n",d30);
% y = awgn(z,40);
% d = z-y;
% d40 = sum(sum(abs(d)));
% fprintf("noise 40 dB=>%f\n",d40);

a=zeros(2,10001);
b=zeros(1,10001);
for i = 1:100
    for j = 1:100
        b(1,j*100+i) = y(j,i);
%         a(j*100+i,1) = j - 50;
%         a(j*100+i,2) = i - 50;
        a(1,j*100+i) = j;
        a(2,j*100+i) = i;
    end
end

%% trainbr

net = feedforwardnet(numnodes,'trainbr');
net.trainParam.epochs = 1000;
% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 80/100;
net.divideParam.valRatio = 10/100;
net.divideParam.testRatio = 10/100;

net = train(net,a,b);
c = net(a);

%% evaluate network

%c=L25e(a);
e=zeros(100);
for i = 1:100
    for j = 1:100
        e(j,i) =  c(1,j*100+i);
    end
end
d = z-e;
n5(k) = sum(sum(abs(d)));
fprintf("Network error= %f\n",n5(k));
% diffxy= max(b)-min(b);
% relerr= errn/diffxy;
% fprintf("Relative error=%f, x-y difference %f\n",relerr,diffxy);

% mesh(e);

%%
end;

fprintf("Average error in data = %f\n",mean(d5(k)));
fprintf("Average error by net  = %f\n",mean(n5(k)));