
%sel = 100;      %  selA = [100,300,1000,3000,10000];
%numnodes = 10;  %  numA = [10, 14, 20, 33, 50, 70, 100];
 selA = [100,300,1000,3000,10000];
 numA = [10, 14, 20, 33, 50, 70, 100];
 resultA = zeros(7);
 resultD = zeros(7);
snr = 15;   %signal-noise-ratio


%% main cycle
for is = 1:5
    
for in = 1:7
    
sel = selA(is);
numnodes = numA(in);
    
d5 = (1:5);
n5 = (1:5);
for k = 1:5

%% full data:
%% prepare data
% z=3*x^3*y - 3*x*y^3 
[X,Y] = meshgrid(-2.45:.05:+2.5);
z = 3.*X.*X.*X.*Y - 3.*X.*Y.*Y.*Y;
% mesh(X,Y,z)

%% *noise*
y = awgn(z,snr);
%d = z-y;

a=zeros(2,10001);
b=zeros(1,10001);
%d=zeros(1,10001);
f=zeros(1,10001);
for i = 1:100
    for j = 1:100
        b(1,(j-1)*100+i) = y(j,i);  % with noise
        f(1,(j-1)*100+i) = z(j,i);  % exact value 
        a(1,(j-1)*100+i) = j;
        a(2,(j-1)*100+i) = i;
    end
end

%% Fisher-Yates    
%preserve exact values for checking
a0 = a;
f0 = f;

for i = 1:sel-1
  j = randi(sel-i);  
  aa = a(1,i);
  a(1,i) = a(1,i+j);
  a(1,i+j) = aa;
  aa = a(2,i);
  a(2,i) = a(2,i+j);
  a(2,i+j) = aa;
  aa = b(1,i);
  b(1,i) = b(1,i+j);
  b(1,i+j) = aa;
  aa = f(1,i);
  f(1,i) = f(1,i+j);
  f(1,i+j) = aa;
end

a1 = zeros(2,sel);
b1 = zeros(1,sel);
f1 = zeros(1,sel);

for i = 1:sel
a1(1,i)=a(1,i);    
a1(2,i)=a(2,i);    
b1(1,i)=b(1,i);    
f1(1,i)=f(1,i);    
end    
    
%% trainbr
d1 = b1 - f1;
d5(k) = sum(sum(abs(d1)));
 fprintf("noise %d dB=>%f . Training points: %d\n",snr,d5(k),sel);

net = feedforwardnet(numnodes,'trainbr');
net.trainParam.epochs = 1000;
% Setup Division of Data for Training, Validation, Testing
net.divideParam.trainRatio = 80/100;
net.divideParam.valRatio = 10/100;
net.divideParam.testRatio = 10/100;

net = train(net,a1,b1);

%% evaluate network
c0 = net(a0);
e0 = c0-f0;
n5(k) = sum(sum(abs(e0)));
fprintf("Nodes: %d.  Network error= %f\n",numnodes,n5(k));
% diffxy= max(b)-min(b);
% relerr= errn/diffxy;
% fprintf("Relative error=%f, x-y difference %f\n",relerr,diffxy);

% mesh(e);

%%
end

resultD(is,in)=mean(d5(k));
fprintf("Average error in data = %f\n",mean(d5(k)));
resultA(is,in)=mean(n5(k));                        % the main result
fprintf("Average error by net  = %f\n",mean(n5(k)));
% resultA is an array of sum of errors per whole 10k samples
end
end
             % rewrite snr value (5, 10, 15) in the name
csvwrite('snr15A.txt',resultA)
csvwrite('snr15D.txt',resultD)    %only data for 10k samples has any meaning